<?
/*********************************************************
**********#	Name				  : Shambhu Prasad Patnaik		   #*******
**********#	Company			: Aynsoft							         #**********
**********#	Copyright (c) www.aynsoft.com 2004	#**********
*********************************************************/
////
function get_theme_info($theme_file) 
{
 if(!file_exists($theme_file) || !is_readable($theme_file))
  return 0;
 else
	$theme_data = implode('', file($theme_file));
	preg_match("|Theme Name:(.*)|i", $theme_data, $theme_name);
	preg_match("|Description:(.*)|i", $theme_data, $description);
	if ( preg_match("|Version:(.*)|i", $theme_data, $version) )
		$version = trim($version[1]);
	else
		$version ='';

	$description = stripslashes(strip_tags(trim($description[1]),'<a><u><b><i>'));
	$name = $theme_name[1];
	$name = trim($name);
	$theme = $name;
	return array('name' => $name, 'description' => $description, 'version' => $version);
}
function check_theme_info($theme_dir) 
{
 if(is_dir($theme_dir))
 {
  if(!get_theme_info($theme_dir.'/info.txt')) 
   return false;
  else  
  {
   if(!file_exists($theme_dir.'/home.php') || !is_readable($theme_dir.'/home.php'))
   {
    return false;
   }
   elseif(!file_exists($theme_dir.'/text.htm') || !is_readable($theme_dir.'/text.htm'))
   {
    return false;
   }
   else
    return true;
  }
 }
 else
  return false;
}

function get_themes() 
{
	
 $themes = array();
	$broken_themes = array();
 $theme_array=array();
 $theme_root = PATH_TO_MAIN_PHYSICAL_THEMES;
 
	// Files in themes directory//
	$themes_dir = @ dir($theme_root);
	if ( $themes_dir )
 {
		while(($theme_dir = $themes_dir->read()) !== false)
  {
			if (is_dir($theme_root . '/' . $theme_dir) && is_readable($theme_root . '/' . $theme_dir)) 
   {
				if ( $theme_dir{0} == '.' || $theme_dir == '..')//
    {
					continue;
				}
    $error =false;
    if(!file_exists($theme_root . '/' . $theme_dir.'/text.htm'))
    {
     $error[]='Home Template is missing';
    }			
    if(!file_exists($theme_root . '/' . $theme_dir.'/home.php'))
    {
     $error[]='home.php file is missing';
    }

    if ($error)
    {
					$broken_themes[$theme_dir] = array( 'name' => $theme_dir, 'error' => implode("\n",$error));
				}
    else
    {
     if($theme_info=get_theme_info($theme_root.'/' . $theme_dir.'/info.txt'))
     {
      $themes[$theme_dir] = $theme_info;
     }
     else
      $themes[$theme_dir] =array( 'name' => $theme_dir, 'description' => '', 'version' => '');

     ////////screenshot///////////////
     $screenshot='';
     foreach (array('png', 'gif', 'jpg', 'jpeg') as $ext)
     {
      if (file_exists($theme_root.'/' . $theme_dir."/screenshot.$ext")) 
      {
       $screenshot = "screenshot.$ext";
       break;
      }
     }
     $themes[$theme_dir]['screenshot']=$screenshot;
     //////////////////////////////////////////
    }
			}
		}
  ///////////////////
  $theme_array=array('broken'=>$broken_themes,'theme'=>$themes);
	}
	return $theme_array;
}
 function display_theme_links($total_rows, $max_rows_per_page=20,$current_page_number, $parameters = '', $page_name = 'page') 
 {
  if ( tep_not_null($parameters) && (substr($parameters, -1) != '&') ) 
   $parameters .= '&';
  // calculate number of pages needing links
  $num_pages = ceil($total_rows / $max_rows_per_page);
  $pages_array = array();
  for ($i=1; $i<=$num_pages; $i++) 
  {
   $pages_array[] = array('id' => $i, 'text' => $i);
  }
  if ($num_pages > 1) 
  {
   $display_links = "<form name='pages' method='get' action='".basename($_SERVER['PHP_SELF'])."'>";
   if ($current_page_number > 1) 
   {
    $display_links .= '<a href="' . basename($_SERVER['PHP_SELF'])."?". $parameters . $page_name . '=' . ($current_page_number - 1) . '" class="splitPageLink">' . PREVNEXT_BUTTON_PREV . '</a>&nbsp;&nbsp;';
   } 
   else 
   {
    $display_links .= PREVNEXT_BUTTON_PREV . '&nbsp;&nbsp;';
   }
   $display_links .= sprintf(TEXT_RESULT_PAGE, tep_draw_pull_down_menu($page_name, $pages_array, $current_page_number, 'onChange="this.form.submit();"'), $num_pages);
   if (($current_page_number < $num_pages) && ($num_pages != 1)) 
   {
    $display_links .= '&nbsp;&nbsp;<a href="' . basename($_SERVER['PHP_SELF'])."?". $parameters . $page_name . '=' . ($current_page_number + 1) . '" class="splitPageLink">' . PREVNEXT_BUTTON_NEXT . '</a>';
   } 
   else 
   {
    $display_links .= '&nbsp;&nbsp;' . PREVNEXT_BUTTON_NEXT;
   }
   if ($parameters != '') 
   {
   if (substr($parameters, -1) == '&') 
    $parameters = substr($parameters, 0, -1);
   $pairs = explode('&', $parameters);
   while (list(, $pair) = each($pairs)) 
   {
    list($key,$value) = explode('=', $pair);
    $display_links .= tep_draw_hidden_field(rawurldecode($key), rawurldecode($value));
   }
  }
  $display_links .= '</form>';
 } 
 else 
 {
  $display_links = sprintf(TEXT_RESULT_PAGE, $num_pages, $num_pages);
 }
 return $display_links;
}
?>